<?php

class ModelfragmentController extends Zend_Controller_Action {
	var $fragment_service;
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/FragmentManagement.php');

		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];
		$this->fragment_service = new FragmentManagement ($serverpath);
	}

	public function indexAction() {

		$modelfragments = $this->fragment_service->findAllModelFragments ();

		$namedfragment = array ();
		$versions = array ();
		foreach ( $modelfragments as $fragment ) {

			if (! isset ( $namedfragment [$fragment ['name']] )) {
				$namedfragment [$fragment ['name']] = $fragment;
				$versions [$fragment ['name']] = $fragment ['version'];
			} else {
				if ($fragment ['version'] > $versions [$fragment ['name']]) {
					$versions [$fragment ['name']] = $fragment ['version'];
				}
			}

		}

		$this->view->modelfragments = $namedfragment;
		$this->view->versions = $versions;
	}

	public function fragmentlistAction() {

		$name = $this->_getParam ( 'name', "" );

		$modelfragments = $this->fragment_service->findAllModelFragments ();
		$namedfragment = array ();

		$versions = array ();
		$lastmodelfragment = null;
		foreach ( $modelfragments as $fragment ) {
			if ($fragment ['name'] == $name) {
				if ($lastmodelfragment == null) {
					$lastmodelfragment = $fragment;
				} else {
					if ($fragment ['version'] > $lastmodelfragment ['version']) {
						$namedfragment [] = $lastmodelfragment;
						$lastmodelfragment = $fragment;
					} else {
						$namedfragment [] = $fragment;
					}
				}
			}

		}

		$this->view->modelfragments = $namedfragment;
		$this->view->lastmodelfragment = $lastmodelfragment;
	}

	public function publishAction() {
		$form = new Application_Form_FragmentSelection ();
		$form->createContent ( true );
		$form->submit->setLabel ('Upload Model Fragment');
		$this->view->form = $form;

		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$filepath = $form->getValue ( 'path' );
				$name = $this->getName ( $filepath );
				$upload = new Zend_File_Transfer_Adapter_Http ();

				$path = APPLICATION_PATH . '/upload/tmp/';
				if (! is_dir ( $path )) {
					mkdir ( $path, 7777, true );
				}
				$upload->addFilter ( 'Rename', array (
						'target' => $handle = tmpfile()
				) );

				try {
					$upload->receive ();
					$tmpURL = $upload->getFileName ();


					$this->fragment_service->publish($tmpURL);

					$this->_helper->redirector ( 'index' );
				} catch ( Zend_File_Transfer_Exception $e ) {
					unlink($tmpURL);
					$this->view->error = 'Erreur de rception du fichier.';
				}
			} else {
				$this->view->error = 'A ModelFragment (*.frg) is required.';
			}
		}
	}


	public function retriveAction() {

	}

	public function deleteAction() {
		$name = $this->_getParam ( 'name', "0" );
		$version = $this->_getParam ( 'version', "0" );

		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {
				$id = $this->getRequest ()->getPost ( 'id' );

				$this->fragment_service->deleteModelFragment ($name,$version);

			}

			$this->_helper->redirector ( 'fragmentlist', 'modelfragment', null, array (
					'name' => $name
			) );

		} else {
			$this->view->account = array (
					"version" => $version,
					"name" => $name
			);
		}
	}

	public function deletelistAction() {
		$name = $this->_getParam ( 'name', "0" );
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {

				$fragmentids = array ();

				foreach ( $this->fragment_service->findAllModelFragments () as $fragment ) {

					if ($fragment ['name'] == $name) {
						$this->fragment_service->deleteModelFragment ($fragment ['name'],$fragment ['version']);
					}
				}


			}

			$this->_helper->redirector ( 'index' );
		} else {
			$this->view->account = array (
					"name" => $name
			);
		}
	}

	public function getName($path) {
		$end = strrpos ( $path, '.' );
		return substr ( $path, 0, $end );
	}

}

