<?php

class MonitoringController extends Zend_Controller_Action {
	
	var $project_service;
	var $role_service;
	var $user_service;
	var $workgroup_service;
	var $fragment_service;
	var $serverpath;
	
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/ProjectManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/RoleManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/WorkgroupManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/UserManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/FragmentManagement.php');
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$this->serverpath = $options['galaxy']['serverpath'];
		
		$this->project_service= new ProjectManagement ( $this->serverpath );
		$this->role_service = new RoleManagement ( $this->serverpath );
		$this->user_service = new UserManagement ( $this->serverpath );
		$this->workgroup_service = new WorkgroupManagement ( $this->serverpath );
		$this->fragment_service = new FragmentManagement ( $this->serverpath );
	}
	
	public function indexAction() {

		

		
		$rolecount = count ( $this->role_service->findAllRoles () );
		$usercount = count ( $this->user_service->findAllParticipants () );
		$workgroupcount = count ( $this->workgroup_service->findAllWorkgroups () );
		$projectcount = count ( $this->project_service->findAllProjects () );
		$fragmentcount = count($this->fragment_service->findAllModelFragments());
		$serverstatus = "STARTED";
		
		$this->view->monitoring = array (
				'serveradress' => "http://" . $this->serverpath,
				'serverstatus' => $serverstatus,
				'rolecount' => $rolecount,
				'usercount' => $usercount,
				'workgroupcount' => $workgroupcount,
				'projectcount' => $projectcount,
				'fragmentcount' => $fragmentcount
		);
	}

}

