<?php

class UserdataController extends Zend_Controller_Action {
	var $project_service;
	var $workgroup_service;
	
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/ProjectManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/WorkgroupManagement.php');
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];
		
		$this->project_service= new ProjectManagement ( $serverpath );
		$this->workgroup_service = new WorkgroupManagement ( $serverpath );
	}
	
	public function indexAction() {
		
		$id = $this->_getParam ( 'id', 0 );
		$firstName = $this->_getParam ( 'firstName', "" );
		$lastName = $this->_getParam ( 'lastName', "" );
		$organisation = $this->_getParam ( 'organisation', "" );
		$address = $this->_getParam ( 'address', "" );
		$country = $this->_getParam ( 'country', "" );
		$email = $this->_getParam ( 'email', "" );
		$phone = $this->_getParam ( 'phone', "" );
		$this->view->user = array (
				'id' => $id,
				'firstName' => $firstName,
				'lastName' => $lastName,
				'organisation' => $organisation,
				'address' => $address,
				'country' => $country,
				'email' => $email,
				'phone' => $phone
		);
		

		$this->view->projects = $this->project_service->findProjectsByParticipant($id);
		$this->view->workgroups = $this->workgroup_service->findWorkgroupsByParticipant($id);
	}

}

