<?php

class WorkgroupdataController extends Zend_Controller_Action {
	

	var $user_service;
	var $workgroup_service;
	
	
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/UserManagement.php');
		require_once (dirname ( __FILE__ ) . '/services/WorkgroupManagement.php');
		
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];
		
		$this->user_service = new UserManagement ( $serverpath );
		$this->workgroup_service = new WorkgroupManagement ( $serverpath );
	}
	
	public function indexAction() {
		$workgroupId = $this->_getParam ( 'id', 0 );
		$name = $this->_getParam ( 'name', "" );
		$description = $this->_getParam ( 'description', "" );
		$this->view->workgroup = array (
				'id' => $workgroupId,
				'name' => $name,
				'description' => $description 
		);
		

		$this->view->users =$this->user_service->findParticipantsByWorkgroup ( $workgroupId );
	}
	
	public function adduserAction() {
		$form = new Application_Form_Selection ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Add User' );
		
		$workgroupId = $this->_getParam ( 'id', 0 );
		
		$userdata = array ();
		$existingusers = array();
		
		foreach ($this->user_service->findParticipantsByWorkgroup($workgroupId) as $user ) {
			$existingusers[$user->id] = $user;		
		}
		
		foreach ( $this->user_service->findAllParticipants () as $user ) {
			if(!isset($existingusers[$user->id])){
				$userdata [$user->id] = $user->firstName . ' ' . $user->lastName;
			}
		}
		
		$form->selection->setMultiOptions ( $userdata );
		$form->populate ( array (
				'id' => $workgroupId 
		) );
		
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$participantId = $form->getValue ( 'selection' );
				$name = $this->_getParam ( 'name', "" );
				$description = $this->_getParam ( 'description', "" );
				$this->workgroup_service->addParticipant ( $workgroupId, $participantId );
				
				$this->_helper->redirector ( 'index', 'workgroupdata', null, array (
						'id' => $workgroupId,
						'name' => $name,
						'description' => $description 
				) );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		}
	
	}
	
	public function removeuserAction() {
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			
			$workgroupId = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "" );
			$description = $this->_getParam ( 'description', "" );
			
			if ($del == 'Yes') {
				$participantId = $this->getRequest ()->getPost ( 'id' );
				$this->workgroup_service->removeParticipant ( $workgroupId, $participantId );
			}
			
			$this->_helper->redirector ( 'index', 'workgroupdata', null, array (
					'id' => $workgroupId,
					'name' => $name,
					'description' => $description 
			) );
		} else {
			$id = $this->_getParam ( 'userid', 0 );
			$firstName = $this->_getParam ( 'firstName', "" );
			$lastName = $this->_getParam ( 'lastName', "" );
			$this->view->account = array (
					"id" => $id,
					"firstName" => $firstName,
					"lastName" => $lastName 
			);
		}
	}

}

