<?php

class Application_Form_User extends Zend_Form
{

	
	public function createContent($edition){

				$this->setName('User');


				$this->addElementPrefixPath('My_Decorator',APPLICATION_PATH.'/forms/decorator','decorator');

		        $id = new Zend_Form_Element_Hidden('id');
		        $id->addFilter('Int');


		        $firstName = new Zend_Form_Element_Text('firstName');
		        $firstName->setLabel('First Name')
		               ->setRequired(true)
		               ->addFilter('StripTags')
		               ->addFilter('StringTrim')
		               ->addValidator('NotEmpty')
					   ->setDecorators(array('Composite'))
					   ->removeDecorator('Errors');

				$lastName = new Zend_Form_Element_Text('lastName');
		        $lastName->setLabel('Last Name')
		               ->setRequired(true)
		               ->addFilter('StripTags')
		               ->addFilter('StringTrim')
		               ->addValidator('NotEmpty')
					   ->setDecorators(array('Composite'))
					   ->removeDecorator('Errors');
		        
				$organisation = new Zend_Form_Element_Text('organisation');
		        $organisation->setLabel('Organisation')
		               ->addFilter('StripTags')
		               ->addFilter('StringTrim')
					   ->setDecorators(array('Composite'))
					   ->removeDecorator('Errors');
					   

      			$address = new Zend_Form_Element_Textarea('address');
		        $address->setLabel('Address')
		               ->addFilter('StripTags')
		               ->setRequired(true)
		               ->addFilter('StringTrim')
		               ->addValidator('NotEmpty')
					   ->setDecorators(array('Composite'))
					   ->removeDecorator('Errors');


				$country = new Zend_Form_Element_Select('country');
				$country->setLabel('Country')
					   ->setRequired(true)
					   ->addFilter('StripTags')
					   ->addFilter('StringTrim')
					   ->addValidator('NotEmpty')
		               ->setMultiOptions(array('France'=>'France', 'Germany'=>'Germany', 'Italy'=>'Italy','United Kingdom'=>'United Kingdom','United States'=>'United States'))
					   ->setDecorators(array('Composite'))
					   ->removeDecorator('Errors');
					   
				$email = new Zend_Form_Element_Text('email');
				$email->setLabel('Email')
				->setRequired(true)
				->addFilter('StripTags')
				->addFilter('StringTrim')
				->addValidator('NotEmpty')
				->setDecorators(array('Composite'))
				->removeDecorator('Errors');
				
				$phone = new Zend_Form_Element_Text('phone');
				$phone->setLabel('Phone')
				->addFilter('StripTags')
				->addFilter('StringTrim')
				->setDecorators(array('Composite'))
				->removeDecorator('Errors');
					   
		        $submit = new Zend_Form_Element_Submit('submit');
		        $submit->setAttrib('id', 'submitbutton');

        		$this->addElements(array($firstName, $lastName ,$organisation,$address,$country,$email,$phone,$id,$submit));
	}
	
	public function init()
    {
    		
    }

}

?>