package org.galaxy.client.api;

import org.galaxy.client.api.impl.ModelFragmentManagementImpl;
import org.galaxy.client.api.impl.ProjectManagementImpl;
import org.galaxy.client.api.impl.RoleManagementImpl;
import org.galaxy.client.api.impl.UserManagementImpl;
import org.galaxy.client.api.impl.WorkgroupManagementImpl;

public class GalaxyService {
	
	private static WorkgroupManagementImpl workgroup;
	private static UserManagementImpl user;
	private static RoleManagementImpl role;
	private static ProjectManagementImpl project;
	private static ModelFragmentManagementImpl fragment;
	
	private String endpoint;
	
	public GalaxyService(String endpoint){
		this.endpoint = endpoint;
	}
	
	public IWorkgroupManagement getWorkgroupManagement(){	
		if(workgroup == null){
			workgroup = new WorkgroupManagementImpl();
			workgroup.setEndpoint(endpoint +"/WorkgroupManagement");
		}
		return workgroup; 
	}
	
	public IRoleManagement getRoleManagement(){	
		if(role == null){
			role = new RoleManagementImpl();
			role.setEndpoint(endpoint +"/RoleManagement");
		}
		return role; 
	}
	
	public IUserManagement getUserManagement(){	
		if(user == null){
			user = new UserManagementImpl();
			user.setEndpoint(endpoint +"/UserManagement");
		}
		return user; 
	}
	
	public IProjectManagement getProjectManagement(){	
		if(project == null){
			project = new ProjectManagementImpl();
			project.setEndpoint(endpoint +"/ProjectManagement");
		}
		return project; 
	}
	
	public IModelFragmentManagement getModelFragmentManagement(){	
		if(fragment == null){
			fragment = new ModelFragmentManagementImpl();
			fragment.setEndpoint(endpoint +"/ModelFragmentManagement");
		}
		return fragment; 
	}
}
