package org.galaxy.client.service.projectmanagement;

public class ProjectManagementProxy implements org.galaxy.client.service.projectmanagement.ProjectManagement {
  private String _endpoint = null;
  private org.galaxy.client.service.projectmanagement.ProjectManagement projectManagement = null;
  
  public ProjectManagementProxy() {
    _initProjectManagementProxy();
  }
  
  public ProjectManagementProxy(String endpoint) {
    _endpoint = endpoint;
    _initProjectManagementProxy();
  }
  
  private void _initProjectManagementProxy() {
    try {
      projectManagement = (new org.galaxy.client.service.projectmanagement.ProjectManagementServiceLocator()).getProjectManagementPort();
      if (projectManagement != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)projectManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)projectManagement)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (projectManagement != null)
      ((javax.xml.rpc.Stub)projectManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public org.galaxy.client.service.projectmanagement.ProjectManagement getProjectManagement() {
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement;
  }
  
  public void addParticipant(java.lang.Integer projectId, java.lang.Integer participantId, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.addParticipant(projectId, participantId, roleIds);
  }
  
  public void addParticipants(java.lang.Integer arg0, int[] participantIds, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.addParticipants(arg0, participantIds, roleIds);
  }
  
  public void addRole(java.lang.Integer projectId, java.lang.Integer roleId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.addRole(projectId, roleId);
  }
  
  public void addRoles(java.lang.Integer projectId, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.addRoles(projectId, roleIds);
  }
  
  public java.lang.Integer createProject(org.galaxy.client.service.projectmanagement.Project project) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement.createProject(project);
  }
  
  public void deleteProject(java.lang.Integer projectId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.deleteProject(projectId);
  }
  
  public void deleteProjects(int[] projectIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.deleteProjects(projectIds);
  }
  
  public org.galaxy.client.service.projectmanagement.Project[] findAllProjects() throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement.findAllProjects();
  }
  
  public org.galaxy.client.service.projectmanagement.Project findProjectById(java.lang.Integer projectId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement.findProjectById(projectId);
  }
  
  public org.galaxy.client.service.projectmanagement.Project[] findProjectByIds(int[] projectIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement.findProjectByIds(projectIds);
  }
  
  public org.galaxy.client.service.projectmanagement.Project[] findProjectsByParticipant(java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    return projectManagement.findProjectsByParticipant(participantId);
  }
  
  public void removeParticipant(java.lang.Integer projectId, java.lang.Integer participantId, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.removeParticipant(projectId, participantId, roleIds);
  }
  
  public void removeParticipants(java.lang.Integer arg0, int[] participantIds, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.removeParticipants(arg0, participantIds, roleIds);
  }
  
  public void removeRole(java.lang.Integer projectId, java.lang.Integer roleId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.removeRole(projectId, roleId);
  }
  
  public void removeRoles(java.lang.Integer projectId, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.removeRoles(projectId, roleIds);
  }
  
  public void updateProject(org.galaxy.client.service.projectmanagement.Project project) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (projectManagement == null)
      _initProjectManagementProxy();
    projectManagement.updateProject(project);
  }
  
  
}