package org.galaxy.client.service.workgroupmanagement;

public class WorkgroupManagementProxy implements org.galaxy.client.service.workgroupmanagement.WorkgroupManagement {
  private String _endpoint = null;
  private org.galaxy.client.service.workgroupmanagement.WorkgroupManagement workgroupManagement = null;
  
  public WorkgroupManagementProxy() {
    _initWorkgroupManagementProxy();
  }
  
  public WorkgroupManagementProxy(String endpoint) {
    _endpoint = endpoint;
    _initWorkgroupManagementProxy();
  }
  
  private void _initWorkgroupManagementProxy() {
    try {
      workgroupManagement = (new org.galaxy.client.service.workgroupmanagement.WorkgroupManagementServiceLocator()).getWorkgroupManagementPort();
      if (workgroupManagement != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)workgroupManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)workgroupManagement)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (workgroupManagement != null)
      ((javax.xml.rpc.Stub)workgroupManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public org.galaxy.client.service.workgroupmanagement.WorkgroupManagement getWorkgroupManagement() {
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement;
  }
  
  public void addParticipant(java.lang.Integer workgroupId, java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.addParticipant(workgroupId, participantId);
  }
  
  public void addParticipants(java.lang.Integer workgroupId, int[] participantIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.addParticipants(workgroupId, participantIds);
  }
  
  public java.lang.Integer createWorkgroup(org.galaxy.client.service.workgroupmanagement.Workgroup workgroup) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement.createWorkgroup(workgroup);
  }
  
  public void deleteWorkgroup(java.lang.Integer workgroupId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.deleteWorkgroup(workgroupId);
  }
  
  public void deleteWorkgroups(int[] workgroupIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.deleteWorkgroups(workgroupIds);
  }
  
  public org.galaxy.client.service.workgroupmanagement.Workgroup[] findAllWorkgroups() throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement.findAllWorkgroups();
  }
  
  public org.galaxy.client.service.workgroupmanagement.Workgroup findWorkgroupById(java.lang.Integer workgroupId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement.findWorkgroupById(workgroupId);
  }
  
  public org.galaxy.client.service.workgroupmanagement.Workgroup[] findWorkgroupsByIds(int[] workgroupsIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement.findWorkgroupsByIds(workgroupsIds);
  }
  
  public org.galaxy.client.service.workgroupmanagement.Workgroup[] findWorkgroupsByParticipant(java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    return workgroupManagement.findWorkgroupsByParticipant(participantId);
  }
  
  public void removeParticipant(java.lang.Integer workgroupId, java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.removeParticipant(workgroupId, participantId);
  }
  
  public void removeParticipants(java.lang.Integer workgroupId, int[] participantIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.removeParticipants(workgroupId, participantIds);
  }
  
  public void updateWorkgroup(org.galaxy.client.service.workgroupmanagement.Workgroup workgroup) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (workgroupManagement == null)
      _initWorkgroupManagementProxy();
    workgroupManagement.updateWorkgroup(workgroup);
  }
  
  
}