package org.galaxy.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;



/**
 * Object-relational persistence model dedicated to ModelFragment
 */
@Entity
@Table(name = "ModelFragment")
public class EModelFragment {
	
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Integer modelfragmentId;

	public Integer getModelfragmentId() {
		return modelfragmentId;
	}

	public void setModelfragmentId(Integer modelfragmentId) {
		this.modelfragmentId = modelfragmentId;
	}

	private String galaxyId;
	
	private String name;
	
	private String description;
	
	private String version;

	@ManyToMany()
	@JoinTable(name = "DEPENDENCIES",
	joinColumns = {
	@JoinColumn(name="FK_MODELFRAGMENTID") 
	},
	inverseJoinColumns = {
	@JoinColumn(name="FK_OWNERMODELFRAGMENTID")})
	private List<EModelFragment> dependencies;
		


	@ManyToMany(mappedBy="dependencies")
	private List<EModelFragment> impactes;
	
	@ManyToMany(cascade=CascadeType.REMOVE,mappedBy="fragments")	
	private List<EWorkgroup> workgroups;
	
	
	public EModelFragment(){
		
	}
	
	public String getGalaxyId() {
		return galaxyId;
	}
	
	public void setGalaxyId(String galaxyId) {
		this.galaxyId = galaxyId;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	public List<EModelFragment> getDependencies() {
		
		if(dependencies == null){
			dependencies = new ArrayList<EModelFragment>();
		}
		
		return dependencies;
	}

	public void setDependencies(List<EModelFragment> dependencies) {
		this.dependencies = dependencies;
	}

	public List<EModelFragment> getImpactes() {
		if(impactes == null){
			impactes = new ArrayList<EModelFragment>();
		}
		return impactes;
	}

	public void setImpactes(List<EModelFragment> impactes) {
		this.impactes = impactes;
	}
	
	public List<EWorkgroup> getWorkgroups() {
		return workgroups;
	}

	public void setWorkgroups(List<EWorkgroup> workgroups) {
		this.workgroups = workgroups;
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof EModelFragment) && ((EModelFragment)obj).getModelfragmentId().equals(getModelfragmentId());
	}
	

}
