package org.galaxy.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;


/**
 * Object-relational persistence model dedicated to Participant
 */
@Entity
@Table(name = "Participant")
public class EParticipant implements Serializable{	
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Integer participantId;	
	
	private String firstName;
	
	private String lastName;
	
	private String address;
	
	private String country;
	
	private String organisation;
	
	private String phone;
	
	private String email;
	
	
	
	@ManyToMany(cascade=CascadeType.REMOVE,mappedBy="participants")
	private List<EWorkgroup> workgroups;

	@OneToMany(cascade=CascadeType.ALL,mappedBy="participant")	
	private List<EProjectParticipant> participation;
	
	public EParticipant(){
		
	}
	
	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public String getOrganisation() {
		return organisation;
	}

	public void setOrganisation(String organisation) {
		this.organisation = organisation;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Integer getParticipantId() {
		return participantId;
	}

	
	public void setParticipantId(Integer id) {
		this.participantId = id;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String first) {
		this.firstName = first;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String last) {
		this.lastName = last;
	}

	public List<EWorkgroup> getWorkgroups() {
		return workgroups;
	}

	public void setWorkgroups(List<EWorkgroup> workgroup) {
		this.workgroups = workgroup;
	}
	
	public List<EProjectParticipant> getParticipation() {
		return participation;
	}
	
	public void setParticipation(List<EProjectParticipant> participants) {
		this.participation = participants;
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof EParticipant) && ((EParticipant)obj).getParticipantId().equals(getParticipantId());
	}

}
