package org.galaxy.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Object-relational persistence model dedicated to Project
 */
@Entity
@Table(name = "Project")
public class EProject implements Serializable{
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Integer projectId;
	
	private String name;
	
	private String description;
	
	private String startDate;
	
	private String endDate;
	
	@ManyToMany(cascade=CascadeType.MERGE)
	@JoinTable(name = "PROJECT_ROLE",
	joinColumns = {
	@JoinColumn(name="FK_PROJECTID") 
	},
	inverseJoinColumns = {
	@JoinColumn(name="FK_ROLEID")})
	private List<ERole> roles;
	
	@OneToMany(cascade=CascadeType.ALL,mappedBy="project")	
	private List<EProjectParticipant> participants;
	
	
	public EProject(){
		
	}
	
	public String getStartDate() {
		return startDate;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public String getEndDate() {
		return endDate;
	}

	public void setEndDate(String endDate) {
		this.endDate = endDate;
	}
	
	public Integer getProjectId() {
		return projectId;
	}
	public void setProjectId(Integer projectId) {
		this.projectId = projectId;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public List<ERole> getRoles() {
		return roles;
	}
	

	public void setRoles(List<ERole> roles) {
		this.roles = roles;
	}
	

	public List<EProjectParticipant> getParticipants() {
		return participants;
	}
	
	public void setParticipants(List<EProjectParticipant> participants) {
		this.participants = participants;
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof EProject) && ((EProject)obj).getProjectId().equals(getProjectId());
	}

}
