package org.galaxy.model;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

/**
 * Object-relational persistence model dedicated to Project Participant relation
 */
@Entity
@Table(name = "ProjectParticipant")
public class EProjectParticipant implements Serializable{
	
	@Id
	@ManyToOne(cascade=CascadeType.MERGE) 
	private EProject project;
	
	@Id
	@ManyToOne(cascade=CascadeType.MERGE)
	private EParticipant participant;
	
	@Id
	@ManyToOne(cascade=CascadeType.MERGE)
	private ERole role;


	public EProject getProject() {
		return project;
	}
	
	public void setProject(EProject project) {
		this.project = project;
	}
	

	public EParticipant getParticipant() {
		return participant;
	}
	public void setParticipant(EParticipant participant) {
		this.participant = participant;
	}
	
 
	public ERole getRole() {
		return role;
	}
	
	public void setRole(ERole role) {
		this.role = role;
	}
}
