package org.galaxy.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Object-relational persistence model dedicated to Project Role
 */
@Entity
@Table(name = "Role")
public class ERole implements Serializable{
	
	@Id
    @GeneratedValue(strategy = GenerationType.AUTO)
	private Integer roleId;
	
	private String name;
	
	private String description;
	
	private String category;
	
	@ManyToMany(cascade=CascadeType.REFRESH,mappedBy="roles")	
	private List<EProject> projects;
	
	@OneToMany(cascade=CascadeType.ALL,mappedBy="role")
	private List<EProjectParticipant> participation;
	
	public ERole(){
		
	}
	
	public String getCategory() {
		return category;
	}

	public void setCategory(String category) {
		this.category = category;
	}

	public Integer getRoleId() {
		return roleId;
	}
	public void setRoleId(Integer roleId) {
		this.roleId = roleId;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	

	public List<EProject> getProjects() {
		return projects;
	}
	public void setProjects(List<EProject> projects) {
		this.projects = projects;
	}
	
	public List<EProjectParticipant> getParticipation() {
		return participation;
	}
	
	public void setParticipation(List<EProjectParticipant> participants) {
		this.participation = participants;
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof ERole) && ((ERole)obj).getRoleId().equals(getRoleId());
	}

}
