package org.galaxy.utility.fragmentanalyser;

import java.io.File;

import org.galaxy.modelfragment.schema.ModelFragment;

/**
 * This interface contains services in order to  manipulate of ModelFragment archive such as 
 * extracting the metadata from the archive
 */
public interface IFragmentAnalyser {
	
	/**
	 * Metadata extraction from the ModelFragment file 
	 * @param fragment
	 * @return
	 * @throws MalformedFragmentException
	 * 
	 */
	public ModelFragment extractMetadata(File fragment) throws MalformedFragmentException;
	
	/**
	 * Validation of ModelFragment
	 * @param fragment File of ModelFragmentmetadata are malformed or incomplete
	 * @throws MalformedFragmentException Throw if 
	 */
	public void validate(File fragment) throws MalformedFragmentException;
	
	
	
	/**
	 * Validation of metadata associated with ModelFragment
	 * @param fragment File of ModelFragmentmetadata are malformed or incomplete
	 * @throws MalformedFragmentException Throw if 
	 */
	public void validateMetadata(ModelFragment metadata) throws MalformedFragmentException;

}
