<?php

class ProjectController extends Zend_Controller_Action {
	var $project_service;
	
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/ProjectManagement.php');
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];
		$this->project_service= new ProjectManagement ( $serverpath );
	}
	
	public function indexAction() {
		$this->view->projects = $this->project_service->findAllProjects ();
	}
	
	public function createAction() {
		$form = new Application_Form_Project ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Create Project' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				$startDate = $form->getValue ( 'startDate' );
				$endDate = $form->getValue ( 'endDate' );
				
				$this->project_service->createProject ( $name, $description, $startDate, $endDate );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		}
	
	}
	
	public function editAction() {
		$form = new Application_Form_Project ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Save Changes' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				
				$id = ( int ) $form->getValue ( 'id' );
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				$startDate = $form->getValue ( 'startDate' );
				$endDate = $form->getValue ( 'endDate' );
				$this->project_service->updateProject ( $id, $name, $description, $startDate, $endDate );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "" );
			$description = $this->_getParam ( 'description', "" );
			$startDate = $this->_getParam ( 'startDate', "" );
			$endDate = $this->_getParam ( 'endDate', "" );
			$form->populate ( array (
					'id' => $id,
					'name' => $name,
					'description' => $description,
					'startDate' => $startDate,
					'endDate' => $endDate 
			) );
		}
	}
	
	public function deleteAction() {
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {
				$id = $this->getRequest ()->getPost ( 'id' );
				
				$this->project_service->deleteProject ( $id );
			
			}
			
			$this->_helper->redirector ( 'index' );
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "" );
			$this->view->account = array (
					"id" => $id,
					"name" => $name 
			);
		}
	}

}

