<?php

class UserController extends Zend_Controller_Action {
	
	var $user_service;
	
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/UserManagement.php');
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];

		$this->user_service = new UserManagement ( $serverpath );		
	}
	
	public function indexAction() {
		$this->view->users = $this->user_service->findAllParticipants ();
	}
	
	public function createAction() {
		$form = new Application_Form_User ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Create User' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$firstName = $form->getValue ( 'firstName' );
				$lastName = $form->getValue ( 'lastName' );
				$organisation = $form->getValue ( 'organisation' );
				$address = $form->getValue ( 'address' );
				$country = $form->getValue ( 'country' );
				$email = $form->getValue ( 'email' );
				$phone = $form->getValue ( 'phone' );
				
				$this->user_service->createParticipant ( $firstName, $lastName, $organisation, $address, $country, $email, $phone );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		}
	
	}
	
	public function editAction() {
		$form = new Application_Form_User ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Save Changes' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				
				$id = ( int ) $form->getValue ( 'id' );
				$firstName = $form->getValue ( 'firstName' );
				$lastName = $form->getValue ( 'lastName' );
				$organisation = $form->getValue ( 'organisation' );
				$address = $form->getValue ( 'address' );
				$country = $form->getValue ( 'country' );
				$email = $form->getValue ( 'email' );
				$phone = $form->getValue ( 'phone' );
				
				$this->user_service->updateParticipant ( $id, $firstName, $lastName, $organisation, $address, $country, $email, $phone );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$firstName = $this->_getParam ( 'firstName', "" );
			$lastName = $this->_getParam ( 'lastName', "" );
			$organisation = $this->_getParam ( 'organisation', "" );
			$address = $this->_getParam ( 'address', "" );
			$country = $this->_getParam ( 'country', "" );
			$email = $this->_getParam ( 'email', "" );
			$phone = $this->_getParam ( 'phone', "" );
			$form->populate ( array (
					'id' => $id,
					'firstName' => $firstName,
					'lastName' => $lastName,
					'organisation' => $organisation,
					'address' => $address,
					'country' => $country,
					'email' => $email,
					'phone' => $phone 
			) );
		}
	}
	
	public function deleteAction() {
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {
				$id = $this->getRequest ()->getPost ( 'id' );
				
				$this->user_service->deleteParticipant ( $id );
			
			}
			
			$this->_helper->redirector ( 'index' );
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$firstName = $this->_getParam ( 'firstName', "" );
			$lastName = $this->_getParam ( 'lastName', "" );
			$this->view->account = array (
					"id" => $id,
					"firstName" => $firstName,
					"lastName" => $lastName 
			);
		}
	}

}

