<?php

class FragmentManagement {
	protected $client;

	function __construct($server) {
		$sbWsdl = $server. '/ModelFragmentManagement?wsdl';
		//$sbWsdl = "C:/Users/aabherve/Desktop/ModelFragmentManagement3.wsdl";
		$this->client = new SoapClient ( $sbWsdl );
	}

	public function findModelFragmentsByNameAndVersion($name, $version) {
		$param = array (
				'findModelFragmentsByNameAndVersion' => array (
						"namePattern" => $name,
						"versionPattern" => $version
				)
		);
		$response = $this->client->__soapCall ( "findModelFragmentsByNameAndVersion", $param );
		if(!isset($response->fragmentdatas->modelfragmentId)){
			$response = $response->fragmentdatas;
		}
		$response = $this->objectToArray ( $response);
		return $this->manageSubArray ($response);
	}

	public function findAllModelFragments() {
		$param = array ();
		$response = $this->client->__soapCall ( "findAllModelFragments", $param );
		if(!isset($response->fragmentdatas->modelfragmentId)){
			$response = $response->fragmentdatas;
		}
		$response = $this->objectToArray ($response);
		return $this->manageSubArray ( $response );
	}

	public function publish($urlfile) {
		$fd = fopen($urlfile, 'rb');
		$size = filesize($urlfile);
		$cont = fread($fd, $size);
		fclose($fd);
		//$encimg = base64_encode($cont);

		$param = array(array(
				"fragmentHandler"  => $cont
		));

		return $this->client->__soapCall("publish", $param);

	}

	public function deleteModelFragment($name,$version) {
		$param = array (
				array (
						"modelFragmentQualifiedName" => $name,
						"version" => $version
				)
		);
		return $this->client->__soapCall ( "deleteModelFragment", $param );
	}

	public function retrieve() {

	}

	public function manageSubArray($mf) {

		foreach($mf as $sub){
			if(isset($sub['dependencies'])){
				if(is_array($sub['dependencies']) && isset($sub['dependencies']['modelfragmentId'])){
					$mf[key($mf)]['dependencies'] = array($sub['dependencies']);
				}else{
					$mf[key($mf)]['dependencies'] = array(get_object_vars($sub['dependencies']));
				}
			}

			if( isset($sub['impactes'])){
				if(is_array($sub['impactes']) && isset($sub['impactes']['modelfragmentId'])){
					$mf[key($mf)]['impactes'] = array($sub['impactes']);
				}else{
					$mf[key($mf)]['impactes'] = array(get_object_vars($sub['impactes']));
				}
			}
			next($mf);
		}
		return $mf;
	}

	public function objectToArray($d) {

		if (is_object ( $d )) {
			$d = get_object_vars ( $d );
		}

		 if(is_array($d)){
		 	while ($value = current($d)) {
		 		$d[key($d)] = $this->objectToArray($value);
		 		next($d);
		 	}
		}
		return $d;
	}
}
?>