<?php

class ProjectManagement {
	protected $client;
	
	function __construct($server) {
		$sbWsdl = $server. '/ProjectManagement?wsdl';
		$this->client = new SoapClient ( $sbWsdl );
	}
	
	public function findAllProjects() {
		$param = array ();
		$response = $this->client->__soapCall ( "findAllProjects", $param );
		return $this->objectToArray ( $response );
	}
	
	public function createProject($name, $description, $startDate, $endDate) {
		$param = array (
				array (
						project => array (
								"name" => $name,
								"description" => $description,
								"startDate" => $startDate,
								"endDate" => $endDate,
								"id" => "" 
						) 
				) 
		);
		return $this->client->__soapCall ( "createProject", $param );
	}
	
	public function updateProject($id, $name, $description, $startDate, $endDate) {
		$param = array (
				array (
						project => array (
								"name" => $name,
								"description" => $description,
								"startDate" => $startDate,
								"endDate" => $endDate,
								"id" => $id 
						) 
				) 
		);
		return $this->client->__soapCall ( "updateProject", $param );
	}
	
	public function deleteProject($id) {
		$param = array (
				array (
						"projectId" => $id 
				) 
		);
		return $this->client->__soapCall ( "deleteProject", $param );
	}
	
	public function addRole($projectId, $roleId) {
		$param = array (
				'addRole' => array (
						"projectId" => $projectId,
						"roleId" => $roleId 
				) 
		);
		return $this->client->__soapCall ( "addRole", $param );
	}
	
	public function removeRole($projectId, $roleId) {
		$param = array (
				'removeRole' => array (
						"projectId" => $projectId,
						"roleId" => $roleId 
				) 
		);
		return $this->client->__soapCall ( "removeRole", $param );
	}
	
	
	public function addParticipant($projectId, $userId,$roleIds){
		$param = array (
				'addParticipant' => array (
						"projectId" => $projectId,
						"participantId" => $userId,
						"roleIds" =>$roleIds
						
				)
		);
		return $this->client->__soapCall ( "addParticipant", $param );
	}
	
	public function removeParticipant($projectId, $userId,$roleIds){
		$param = array (
				'removeParticipant' => array (
						"projectId" => $projectId,
						"participantId" => $userId,
						"roleIds" =>$roleIds
	
				)
		);
		return $this->client->__soapCall ( "removeParticipant", $param );
	}
	
	public function findProjectsByParticipant($id) {
		$param = array (
				array (
						"participantId" => $id
				)
		);
		$response = $this->client->__soapCall ( "findProjectsByParticipant", $param );
		return $this->objectToArray ( $response );
	}
	
	public function objectToArray($d) {
		
		if (is_object ( $d )) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars ( $d );
		}
		
		if (count ( $d ) > 0) {
			foreach ( $d as $val ) {
				if (is_array ( $val )) {
					return $val;
				}
			
			}
			return $d;
		}
	}
}
?>