<?php

class WorkgroupController extends Zend_Controller_Action {
	var $workgroup_service;
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/WorkgroupManagement.php');
		

		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];
		
		$this->workgroup_service = new WorkgroupManagement ( $serverpath );
	}
	
	public function indexAction() {
		$this->view->workgroups = $this->workgroup_service->findAllWorkgroups ();
	}
	
	public function createAction() {
		$form = new Application_Form_Workgroup ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Create Workgroup' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				
				$this->workgroup_service->createWorkgroup ( $name, $description );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		}
	
	}
	
	public function editAction() {
		$form = new Application_Form_Workgroup ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Save Changes' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				
				$id = ( int ) $form->getValue ( 'id' );
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				
				$this->workgroup_service->updateWorkgroup ( $id, $name, $description );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "" );
			$description = $this->_getParam ( 'description', "" );
			$form->populate ( array (
					'id' => $id,
					'name' => $name,
					'description' => $description 
			) );
		}
	}
	
	public function deleteAction() {
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {
				$id = $this->getRequest ()->getPost ( 'id' );
				
				$this->workgroup_service->deleteWorkgroup ( $id );
			
			}
			
			$this->_helper->redirector ( 'index' );
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "" );
			$this->view->account = array (
					"id" => $id,
					"name" => $name 
			);
		}
	}

}

