<?php

class UserManagement {
	protected $client;
	
	function __construct($server) {
		$sbWsdl = $server. '/UserManagement?wsdl';
		$this->client = new SoapClient ( $sbWsdl );
	}
	
	public function findAllParticipants() {
		$param = array ();
		$response = $this->client->__soapCall ( "findAllParticipants", $param );
		return $this->objectToArray ( $response );
	}
	
	public function findParticipantsByWorkgroup($id) {
		$param = array (
				array (
						"workgroupId" => $id 
				) 
		);
		$response = $this->client->__soapCall ( "findParticipantsByWorkgroup", $param );
		return $this->objectToArray ( $response );
	}
	
	public function findParticipantsByProject($id) {
		$param = array (
				array (
						"projectId" => $id
				)
		);
		$response = $this->client->__soapCall ( "findParticipantsByProject", $param );
		return $this->objectToArray ( $response );
	}
	
	
	
	public function createParticipant($firstName, $lastName, $organisation, $address, $country, $email, $phone) {
		
		$param = array (
				array (
						participant => array (
								"firstName" => $firstName,
								"lastName" => $lastName,
								"organisation" => $organisation,
								"address" => $address,
								"country" => $country,
								"email" => $email,
								"phone" => $phone,
								"id" => "" 
						) 
				) 
		);
		return $this->client->__soapCall ( "createParticipant", $param );
	}
	
	public function updateParticipant($id, $firstName, $lastName, $organisation, $address, $country, $email, $phone) {
		$param = array (
				array (
						participant => array (
								"firstName" => $firstName,
								"lastName" => $lastName,
								"organisation" => $organisation,
								"address" => $address,
								"country" => $country,
								"email" => $email,
								"phone" => $phone,
								"id" => $id 
						) 
				) 
		);
		return $this->client->__soapCall ( "updateParticipant", $param );
	}
	
	public function deleteParticipant($id) {
		$param = array (
				array (
						"participantId" => $id 
				) 
		);
		return $this->client->__soapCall ( "deleteParticipant", $param );
	}
	
	public function objectToArray($d) {
		
		if (is_object ( $d )) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars ( $d );
		}
		
		if (count ( $d ) > 0) {
			foreach ( $d as $val ) {
				if (is_array ( $val )) {
					return $val;
				}
			
			}
			return $d;
		}
	}
}
?>